; #########################################################################

  ; --------------------------------------------------
  ; This procedure was written by Raymond Filiatreault
  ; --------------------------------------------------

    .386
    .model flat, stdcall  ; 32 bit memory model
    option casemap :none  ; case sensitive

    .code

; #########################################################################

sqrt32 proc public uInt:DWORD
	
    ; -------------------------------------------------------------
    ; Returns the square root of a 32-bit unsigned integer
    ; The result is rounded to the closest integer.
    ;
    ; eax, ecx, edx used
    ;
    ; EXAMPLE: invoke sqrt32, 32_bit_value
    ; 
    ; Returns result in eax
    ;
    ; -------------------------------------------------------------

    mov edx,uInt
    xor eax,eax
    mov ecx,40000000h

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr10
  @@:
    sub eax,ecx
sqr10:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr20
  @@:
    sub eax,ecx
sqr20:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr30
  @@:
    sub eax,ecx
sqr30:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr40
  @@:
    sub eax,ecx
sqr40:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr50
  @@:
    sub eax,ecx
sqr50:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr60
  @@:
    sub eax,ecx
sqr60:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr70
  @@:
    sub eax,ecx
sqr70:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr80
  @@:
    sub eax,ecx
sqr80:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqr90
  @@:
    sub eax,ecx
sqr90:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrA0
  @@:
    sub eax,ecx
sqrA0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrB0
  @@:
    sub eax,ecx
sqrB0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrC0
  @@:
    sub eax,ecx
sqrC0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrD0
  @@:
    sub eax,ecx
sqrD0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrE0
  @@:
    sub eax,ecx
sqrE0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrF0
  @@:
    sub eax,ecx
sqrF0:
    shr eax,1
    shr ecx,2

    add eax,ecx
    cmp eax,edx
    ja  @F
    sub edx,eax
    add eax,ecx
    jmp sqrG0
  @@:
    sub eax,ecx
sqrG0:
    shr eax,1

    cmp eax,edx
    ja  @F
    inc eax

  @@:    
    ret
    
sqrt32 endp

; #########################################################################

end
